#! /usr/bin/perl

$lst = $ARGV[0];

if (! $lst) {
	$lst = <STDIN>;
	chomp($lst);
	if (! $lst) {
		usage();
		exit 0;
	}
} else {
	if ($lst eq "-h" || $lst eq "-H"){
		print "Help for validate.pl --\n";
		usage();
		exit 0;
	}
}

@addrs = split(/,/, $lst);
$addrsLng = @addrs;
if ($addrsLng == 0) {
	usage();
	exit 0;
}

$val = "";
$inval = "";
$dups = "";

foreach $addr (@addrs) {
	if (is_valid_email2($addr)) {
		if (index($val,$addr) == -1) {
			$val .= "$addr\n";
		} else {
			$dups .= "$addr\n";
		}
	} else {
		$inval .= "$addr\n";
	}
}

if ((length $val) != 0) {
	$val = substr($val,0,length($val)-1);
}
if (length($dups) != 0) {
	$dups = substr($dups,0,length($dups)-1);
}
if (length($inval) != 0) {
	$inval = substr($inval,0,length($inval)-1);
}

print "$val|";
print "$inval|";
print "$dups";

sub is_valid_email ($) { # credits to David T. McWherter [cache atsymbol cs.cmu.edu]
	my ($addr) = @_;
	my $atext = qr/[A-Za-z0-9\!\#\$\%\&\'\*\+\-\/\=\?\^\_\`\{\|\+\~]/;
	my $dot_atom_text = qr/$atext+(\.$atext+)*/;

	my $no_ws_ctl_char = qr/[\x01-\x08\x0b\x0c\x0e-\x1f\x7f]/;
	my $qtext_char = qr/([\x21\x23-\x5b\x5d-\x7e]|$no_ws_ctl_char)/;
	my $text = qr/[\x01-\x09\x0b\x0c\x0e-\x7f]/;
	my $qtext = qr/($qtext_char|\\$text)*/;
	my $quoted_string = qr/"$qtext"/;

	my $quotedpair = qr/\\$text/;
	my $dtext = qr/[\x21-\x5a\x5e-\x7e\x01-\x08\x0b\x0c\x0e-\x1f\x7f]/;
	my $dcontent = qr/($dtext|$quotedpair)/;
	my $domain_literal = qr/\[(${dcontent})*\]/;

	if ( $addr =~ /^($dot_atom_text|$quoted_string)\@($dot_atom_text|$domain_literal)$/ ) { 
		return 1;
	} else {
		return 0;
	}
}

# ^[a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$
# ^([a-zA-Z0-9_\-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9\-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$
# ^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$

sub is_valid_email2 ($) { # credits to I can't remember who for the regexp
	($q) = @_;
	if ($q =~ /^([a-zA-Z0-9_\-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9\-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/ ) {
		return 1;
	} else {
		return 0;
	}
}

sub usage(){
	print "\nUSAGE\n";
	print "validate.pl [email addresses]\n\n";
	print "[email addresses] is a string (eg, \"foo\@foo.net\") or a comma-separated list (eg, \"foo\@foo.net,foo\@foo.bar,foo\@blah.org\". Do not include spaces!!!\n\n";
	print "Result: will print a list of a) Valid email addresses, LF separated; b) Invalid email addresses, LF separated; c) Duplicate email addresses, LF separated. a, b & c will be separated by \"|\".\n\n";
}